<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- java-module.qdoc -->
  <title>java QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
<li class="level2"><a href="#relevant-file-tags">Relevant File Tags</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">java QML Type</h1>
<span class="subtitle"></span>
<!-- $$$java-brief -->
<p>Provides Java support. <a href="#details">More...</a></p>
<!-- @@@java -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsModules .</td></tr><tr><td class="memItemLeft rightAlign topAlign"> Since:</td><td class="memItemRight bottomAlign"> Qbs 1.4</td></tr></table></div><ul>
<li><a href="qml-qbsmodules-java-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#additionalClassPaths-prop">additionalClassPaths</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#additionalCompilerFlags-prop">additionalCompilerFlags</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#additionalJarFlags-prop">additionalJarFlags</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#bootClassPaths-prop">bootClassPaths</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#compilerFilePath-prop">compilerFilePath</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#compilerName-prop">compilerName</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#enableWarnings-prop">enableWarnings</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#interpreterFilePath-prop">interpreterFilePath</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#interpreterName-prop">interpreterName</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#jarFilePath-prop">jarFilePath</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#jarName-prop">jarName</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#jdkIncludePaths-prop">jdkIncludePaths</a></b></b> : pathList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#jdkPath-prop">jdkPath</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#languageVersion-prop">languageVersion</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#manifest-prop">manifest</a></b></b> : var</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#manifestClassPath-prop">manifestClassPath</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#runtimeVersion-prop">runtimeVersion</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-java.html#warningsAsErrors-prop">warningsAsErrors</a></b></b> : bool</li>
</ul>
<!-- $$$java-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>The <code>java</code> module contains the properties and rules for building Java projects.</p>
<a name="relevant-file-tags"></a>
<h3 id="relevant-file-tags">Relevant File Tags</h3>
<a name="filetags-java"></a><div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Tag</th><th >Auto-tagged File Names</th><th >Since</th><th >Description</th></tr></thead>
<tr valign="top" class="odd"><td ><code>&quot;java.class&quot;</code></td><td >-</td><td >1.4</td><td >This tag is attached to the output artifacts of the rule that runs the <code>javac</code> tool.</td></tr>
<tr valign="top" class="even"><td ><code>&quot;java.jar&quot;</code></td><td >-</td><td >1.4</td><td >This tag is attached to the output artifacts of the rule that runs the <code>jar</code> tool.</td></tr>
<tr valign="top" class="odd"><td ><code>&quot;java.java&quot;</code></td><td ><code>*.java</code></td><td >1.4</td><td >Source files with this tag serve as inputs to the rule running the <code>javac</code> tool.</td></tr>
<tr valign="top" class="even"><td ><code>&quot;java.manifest&quot;</code></td><td ><code>*.mf</code></td><td >1.8</td><td >The contents of files with this tag will be aggregated with the values in <a href="qml-qbsmodules-java.html#manifest-prop">manifest</a>.</td></tr>
</table></div>
<!-- @@@java -->
<h2>Property Documentation</h2>
<!-- $$$additionalClassPaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="additionalClassPaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">additionalClassPaths</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The locations beside this product's class output path to consider when compiling.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@additionalClassPaths -->
<br/>
<!-- $$$additionalCompilerFlags -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="additionalCompilerFlags-prop">
<td class="tblQmlPropNode"><p>
<span class="name">additionalCompilerFlags</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of compiler flags not covered by any of the properties in this module.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@additionalCompilerFlags -->
<br/>
<!-- $$$additionalJarFlags -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="additionalJarFlags-prop">
<td class="tblQmlPropNode"><p>
<span class="name">additionalJarFlags</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of archiver flags not covered by any of the properties in this module.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@additionalJarFlags -->
<br/>
<!-- $$$bootClassPaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="bootClassPaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">bootClassPaths</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of non-standard bootstrap class files.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@bootClassPaths -->
<br/>
<!-- $$$compilerFilePath -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="compilerFilePath-prop">
<td class="tblQmlPropNode"><p>
<span class="name">compilerFilePath</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The command to invoke when compiling Java sources.</p>
<p>Default: <a href="qml-qbsmodules-java.html#compilerName-prop">compilerName</a>, prefixed by <a href="qml-qbsmodules-java.html#jdkPath-prop">jdkPath</a> if it is defined.</p>
</div></div><!-- @@@compilerFilePath -->
<br/>
<!-- $$$compilerName -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="compilerName-prop">
<td class="tblQmlPropNode"><p>
<span class="name">compilerName</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The file name of the Java compiler.</p>
<p>Default: <code>&quot;javac&quot;</code></p>
</div></div><!-- @@@compilerName -->
<br/>
<!-- $$$enableWarnings -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="enableWarnings-prop">
<td class="tblQmlPropNode"><p>
<span class="name">enableWarnings</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Whether warnings are emitted when compiling Java sources.</p>
<p>Default: <code>true</code></p>
</div></div><!-- @@@enableWarnings -->
<br/>
<!-- $$$interpreterFilePath -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="interpreterFilePath-prop">
<td class="tblQmlPropNode"><p>
<span class="name">interpreterFilePath</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The command to invoke when executing Java code.</p>
<p>Default: <a href="qml-qbsmodules-java.html#interpreterName-prop">interpreterName</a>, prefixed by <a href="qml-qbsmodules-java.html#jdkPath-prop">jdkPath</a> if it is defined.</p>
</div></div><!-- @@@interpreterFilePath -->
<br/>
<!-- $$$interpreterName -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="interpreterName-prop">
<td class="tblQmlPropNode"><p>
<span class="name">interpreterName</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The file name of the Java interpreter.</p>
<p>Default: <code>&quot;java&quot;</code></p>
</div></div><!-- @@@interpreterName -->
<br/>
<!-- $$$jarFilePath -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="jarFilePath-prop">
<td class="tblQmlPropNode"><p>
<span class="name">jarFilePath</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The command to run when creating or extracting <code>jar</code> files.</p>
<p>Default: <a href="qml-qbsmodules-java.html#jarName-prop">jarName</a>, prefixed by <a href="qml-qbsmodules-java.html#jdkPath-prop">jdkPath</a> if it is defined.</p>
</div></div><!-- @@@jarFilePath -->
<br/>
<!-- $$$jarName -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="jarName-prop">
<td class="tblQmlPropNode"><p>
<span class="name">jarName</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The file name of the <code>jar</code> tool.</p>
<p>Default: <code>&quot;jar&quot;</code></p>
</div></div><!-- @@@jarName -->
<br/>
<!-- $$$jdkIncludePaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="jdkIncludePaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">jdkIncludePaths</span> : <span class="type">pathList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of include paths for native header files.</p>
<p>Applications using JNI to interface with native code should add these paths to <a href="qml-qbsmodules-cpp.html#includePaths-prop">cpp.includePaths</a>.</p>
<p>Default: Determined automatically.</p>
<p>This property was introduced in Qbs 1.4&#x2e;1.</p>
</div></div><!-- @@@jdkIncludePaths -->
<br/>
<!-- $$$jdkPath -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="jdkPath-prop">
<td class="tblQmlPropNode"><p>
<span class="name">jdkPath</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The base path of the Java Development Kit (JDK).</p>
<p>This is equivalent to the <code>JAVA_HOME</code> environment variable, and by default will be determined automatically from one of the following:</p>
<ul>
<li><code>JAVA_HOME</code> environment variable (all platforms)</li>
<li>Registry (Windows)</li>
<li><code>java_home</code> tool (<a href="nolink">macOS</a>)</li>
<li>Known JDK paths (other Unix platforms)</li>
</ul>
<p>Default: Determined automatically.</p>
</div></div><!-- @@@jdkPath -->
<br/>
<!-- $$$languageVersion -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="languageVersion-prop">
<td class="tblQmlPropNode"><p>
<span class="name">languageVersion</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The Java language version to interpret source code as.</p>
<p>If left undefined, the compiler will use its default.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@languageVersion -->
<br/>
<!-- $$$manifest -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="manifest-prop">
<td class="tblQmlPropNode"><p>
<span class="name">manifest</span> : <span class="type">var</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The properties to add to the manifest file when building a JAR.</p>
<p>The contents of this property will be aggregated with the values from any files tagged <a href="qml-qbsmodules-java.html#filetags-java">&quot;java.manifest&quot;</a>.</p>
<p>If this property and a manifest file contain the same key, this property will take precedence. If left undefined, this property will not be taken into account.</p>
<p>Default: Undefined</p>
<p>This property was introduced in Qbs 1.4&#x2e;2.</p>
</div></div><!-- @@@manifest -->
<br/>
<!-- $$$manifestClassPath -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="manifestClassPath-prop">
<td class="tblQmlPropNode"><p>
<span class="name">manifestClassPath</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of entries to add to the manifest's Class-Path when building a JAR.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@manifestClassPath -->
<br/>
<!-- $$$runtimeVersion -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="runtimeVersion-prop">
<td class="tblQmlPropNode"><p>
<span class="name">runtimeVersion</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The version of the Java runtime to generate compatible bytecode for.</p>
<p>If left undefined, the compiler will use its default.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@runtimeVersion -->
<br/>
<!-- $$$warningsAsErrors -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="warningsAsErrors-prop">
<td class="tblQmlPropNode"><p>
<span class="name">warningsAsErrors</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>If this property is <code>true</code>, the compiler will abort where it would normally emit a warning.</p>
<p>Default: <code>false</code></p>
</div></div><!-- @@@warningsAsErrors -->
<br/>
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
